import java.util.concurrent.Semaphore;

class CounterS {
    int counter = 0;
    final int PEOPLE = 1000;
    Semaphore sem = new Semaphore(1); // Semaphore to control acccess to counter

    public CounterS() {
        try {
            Gate east = new Gate();
            Gate west = new Gate();

            long startTime = System.currentTimeMillis();

            east.start();west.start();
            east.join();west.join();

            long stopTime = System.currentTimeMillis();
            long elapsedTime = stopTime - startTime;

            System.out.println("counter = " + counter + "; time: " + elapsedTime + "ms");

        } catch (InterruptedException e) {
            System.out.println(e);
        }

    }

    public static void main(String[] args) {
        new CounterS();
    }

    class Gate extends Thread {
        public void run() {
            try {
                for (int i = 0; i < PEOPLE; i++) {
                    sem.acquire(); // Enter critical section
                    counter++;     // Update variable
                    sem.release(); // Leave critical section
                }
            } catch (InterruptedException e) {
                System.out.println(e);
            }
        }
    }
}
